#!/usr/bin/perl

# "columns.pl", a script for use with the Forum News Gateway
# copyright 1995 by Swarthmore College

# Read lines of tab-delimited "columns" from standard input
# and print selected columns in the same format to standard out.
# You can also duplicate and reorder columns.

# It's meant for selecting columns from the output of
# "Scripts/accounts.pl", but it works for other stuff too.

# --

if (!&ProcessArgs()) {
	print STDERR "usage: perl $0 [<n1> [<n2> ...]]\n",
				 "    select specified columns from tab-delimited input\n",
				 "    e.g. 'perl $0 1 3 1' retains columns 1, 3 and 1 in that order\n",
				 "    the leftmost column is column 1\n";
	exit (1);
}

# --

while ($line = <STDIN>) {
	@columns = split (/\t/, $line);
	print join ("\t", @columns [@indices]),"\n";
}

exit (0);

# --

# Process the command-line arguments, setting @indices.
# Return 1 if all is well, 0 if there is any error in the command line.

sub ProcessArgs {
	return 0 if (@ARGV < 1);				# at least one argument required
	
	@indices = ();
	foreach $arg (@ARGV) {
		return 0 if (0+$arg <= 0);			# fail if the argument is non-numeric or < 1
		push (@indices, $arg-1);
	}
	
	return 1;
}
